#![cfg_attr(feature="unstable", feature(impl_trait_in_assoc_type))] // XXX: Re-work `re::RegexEngine` to be able to remove this if we can, so we can use non-allocating `try_exec()` on stable...

mod re;
mod text;
mod args;

use color_eyre::{
    eyre::{
        self,
        eyre,
        WrapErr as _,
    },
    SectionExt as _, Help as _,
};

fn initialise() -> eyre::Result<()>
{
    color_eyre::install()?;
    Ok(())
}

fn main() -> eyre::Result<()>
{
    initialise().wrap_err("Fatal: Failed to install panic handle")?;
    let cli = args::parse_cli();//.wrap_err("Error parsing command-line arguments")?;

    eprintln!("{:#?}", cli);
    return Ok(());

    let args: Vec<String> = std::env::args().collect();

    if args.len() < 4 {
	println!("Usage: {} <str> <regex> <group>", args[0]);
	println!("Pass `-' as `<str>' to read lines from stdin");
	std::process::exit(1);
    } else {
	let re = re::Regex::compile(&args[2])?;
	let text = &args[1];
	let group: usize = args[3].parse().expect("Invalid group number.");

	if text == "-" {
	    text::stdin_lines(|text| -> Result<bool, re::Error> {
		match re.exec(&text)? {
		    Some(g) if g.len() > group => println!("{}", &g[group]),
		    _ => (),
		}
		Ok(true)
	    })?;
	} else {

	    match re.exec(&text)? {
		Some(g) if g.len() > group => println!("{}", &g[group]),
		_ => (),
	    }
	}
    }
    Ok(())
}
